/*
 * ar4c-dcdc - a2f.h
 *
 * Copyright (C) 2014  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 */

#ifndef A2F_H_INCLUDED
#define A2F_H_INCLUDED

struct a2f_state {
	unsigned int y;
	unsigned int y2;
};

static inline void a2f_reset(struct a2f_state *p)
{
	p->y = 0;
	p->y2 = 0;
}

static inline void a2f_step(struct a2f_state *p, unsigned char shift,
		unsigned char x)
{
	unsigned int r = 1 << (shift - 1);
	unsigned int y;
	unsigned int y2;

	y = p->y;
	y += x - (y >> shift);
	p->y = y;

	y2 = p->y2;
	y2 += ((y + r) >> shift) - (y2 >> shift);
	p->y2 = y2;
}

static inline unsigned int a2f_get(struct a2f_state *p, unsigned char shift)
{
	unsigned int r = 1 << (shift - 1);

	return (p->y2 + r) >> shift;
}
#endif
