/*
 * ar4c-dcdc - eeprom-avr.c
 *
 * Copyright (C) 2014  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <compiler.h>

#include <avr/io.h>
#include <avr/interrupt.h>
#include <storage.h>

void ee_write(u8 x, unsigned int addr)
{
	while (EECR & BIT(EEWE))
		cpu_relax();
	EEAR = addr;
	EEDR = x;
	cli();
	EECR |= BIT(EEMWE);
	EECR |= BIT(EEWE);
	sei();
}

u8 ee_read(unsigned int addr)
{
	while (EECR & BIT(EEWE))
		cpu_relax();
	EEAR = addr;
	EECR |= BIT(EERE);
	return EEDR;
}
